require 'globals'
require 'game'
require 'menu'
require 'help'

game = nil

function love.load()
	--sounds["music"]:play()
	initScore()
	
	game = Menu:new()
	game:load()
end

function love.update(dt)
	game:update(dt)
	
	if game:newGame() == "help" then
		game = Help:new()
		game:load()
	elseif game:newGame() then
		game = Game:new()
		game:load()
	end
end

function love.draw()
	game:draw()
end

function love.keypressed(key)
    if key == "escape" then
		initScore()
		game = Game:new()
		game:load()
        --love.event.quit()
	else
		game:keypressed(key)
   end
end

function love.mousereleased(x,y,button)
	game:mousereleased(x,y)
end
