require 'middleclass'
require 'util'
require 'globals'
require 'art'

require 'particle'
require 'wall'
require 'mousecircle'

Menu = class('Menu')

function Menu:load()

	setGlobals()
	self.newgame = false

	self.stars = {}
	for i=1,100 do
		table.insert( self.stars, {math.random(0,WIDTH),math.random(0,HEIGHT)} )
	end 

	self.time = 2
end

function Menu:update(dt)
	self.time = self.time + dt

	dt = dt * 2
	
	for i=1,#self.stars do
		self.stars[i][1] = self.stars[i][1]-(10*dt)
	end
	if (math.random(0,1000) <= 1000*dt) then
		table.insert( self.stars, {WIDTH+5,math.random(0,HEIGHT)} )
	end
end

function Menu:draw()
	--love.graphics.setCaption(love.timer.getFPS( ))

	-- background
	love.graphics.setColor(26,26,26,255)
	love.graphics.rectangle("fill",0,0,WIDTH,HEIGHT)

	love.graphics.setColor(180,180,180,255)

	for i=1,#self.stars do
		love.graphics.rectangle("fill",self.stars[i][1],self.stars[i][2],2,2)
	end

	love.graphics.setColor(6,114,181,255)
	love.graphics.circle("fill",HWIDTH,3.85*HEIGHT,3*HEIGHT)

	love.graphics.setColor(255,255,255,255)
	love.graphics.draw(art["satellite1"],HWIDTH,HHEIGHT-90)
	local alpha = 1 - (self.time % 5)
	if alpha < 0 then alpha = 0 end
	love.graphics.setColor(255,255,255,255*alpha)
	love.graphics.draw(art["satellite2"],HWIDTH,HHEIGHT-90)



	love.graphics.setColor(255,255,255,255)
	love.graphics.setFont(font64)
	love.graphics.printf("ORBITAL ION CANNON",0,30,WIDTH,"center")
	love.graphics.setFont(font42)
	love.graphics.printf("VERSUS CONSERVATION OF CHARGE",0,100,WIDTH,"center")
	
	love.graphics.setFont(font42)
	love.graphics.print("NEW GAME",90,HHEIGHT-75)
	love.graphics.print("HELP",90,HHEIGHT-25)
	love.graphics.print("QUIT",90,HHEIGHT+25)
end

function Menu:newGame()
	return self.newgame
end

function Menu:keypressed()
end

function Menu:mousereleased(x,y)
	if y < HHEIGHT-75 then return
	elseif y < HHEIGHT-25 then self.newgame = "help"
	elseif y < HHEIGHT+25 then self.newgame = "help"
	elseif y < HHEIGHT+75 then love.event.quit()
	end
end
