require 'middleclass'
require 'art'

MouseCircle = class('MouseCircle')

function MouseCircle:initialize()
	self.type = "MouseCircle"
	self.mouseuptime = 0
	self.power = 0
end

function MouseCircle:update(dt)
end

function MouseCircle:draw()
	if not (love.mouse.isDown("r") or love.mouse.isDown("l")) then
		self.mouseuptime = love.timer.getTime()
		self.power = 0
	else

		local timesince = love.timer.getTime() - self.mouseuptime
		local alpha = 1.5*(200-(200/(timesince+1)) + 55)
		local radius = 30/(timesince+0.3)
		self.power = 5-(5/(timesince+1))

		if alpha > 255 then alpha = 255 end
	
		love.graphics.setColor(128,128,128,alpha)

		local x,y = love.mouse.getPosition()
		love.graphics.circle("fill",x,y,radius,32)

	end
end

function MouseCircle:mouseDown()
end
