-- rect = x,y,width,height

function inBox(point,rect)	
	if (	point[1] > rect[1] 
		and point[1] < rect[1]+rect[3]
		and point[2] > rect[2]
		and point[2] < rect[2]+rect[4])
		then return true
		else return false
	end
end

function inBoxOffset(point,rect,a,b)	
	if (	point[1]+a > rect[1] 
		and point[1]+a < rect[1]+rect[3]
		and point[2]+b > rect[2]
		and point[2]+b < rect[2]+rect[4])
		then return true
		else return false
	end
end

function inCircle(point,centre,r)
	local dist2 = math.pow(point[1]-centre[1],2)+math.pow(point[2]-centre[2],2)
	if dist2 < math.pow(r,2) then return true
	else return false
	end 
end

function overlapBox(rect1,rect2)
	if  rect1[1]         < rect2[1]+rect2[3]
	and rect1[1]+rect[3] > rect2[1]
	and rect1[2]         < rect2[2]+rect2[4]
	and rect1[2]+rect[4] > rect2[2]
		then return false
		else return true
	end
end

function getIndex(t,val)
    for k,v in ipairs(t) do 
        if v == val then return k end
    end
end

function CopyTable(t)
  local t2 = {}
  for k,v in pairs(t) do
    t2[k] = v
  end
  return t2
end

function inDiamond(point,rect)
	
	if not inBox(point,rect) then return false end
	
	top = {0.5*(rect[1]+rect[1]+rect[3]),rect[2]}
	base = {0.5*(rect[1]+rect[1]+rect[3]),rect[2]+rect[4]}
	left = {rect[1],0.5*(rect[2]+rect[2]+rect[4])}
	right = {rect[1]+rect[3],0.5*(rect[2]+rect[2]+rect[4])}
	
	eq1 = (point[1] - top[1])/(point[2]-top[2]) > (left[1] - top[1])/(left[2]-top[2])
	if not eq1 then return false end
	eq2 = (point[1] - top[1])/(point[2]-top[2]) < (right[1] - top[1])/(left[2]-top[2])
	if not eq2 then return false end
	
	eq3 = (point[1] - base[1])/(point[2]-base[2]) < (left[1] - base[1])/(left[2]-base[2])
	if not eq3 then return false end
	eq4 = (point[1] - base[1])/(point[2]-base[2]) > (right[1] - base[1])/(left[2]-base[2])
	if not eq4 then return false end
	
	return true
end

function sqrdistance(point1,point2)
	local dist = math.pow(point1[1]-point2[1],2)
	dist = dist + math.pow(point1[2]-point2[2],2)
	return dist
end

function distance(point1,point2)
	local dist = math.pow(point1[1]-point2[1],2)
	dist = dist + math.pow(point1[2]-point2[2],2)
	dist = math.pow(dist,0.5)
	return dist
end

function distancefail(point1,point2)
	local dist = math.pow(math.pow(point1[1]-point2[1],2),0.5)
	dist = dist + math.pow(math.pow(point1[2]-point2[2],2),0.5)
	return dist
end

function modulo(a,b)
	return a - math.floor(a/b)*b
end
