require 'middleclass'
--require 'art'

Wall = class('Wall')

function Wall:initialize(world,right)
	self.type = "Wall"
	self.world = world
	self.right = right

	local pointcount = 5
	self.blocks = {{},{},{},{},{}}

	for i=1,pointcount do
		self.blocks[i].body = love.physics.newBody(self.world, self.x, self.y, "static")
	end

	local n = 5
	if right then
		self.points = {
			{HWIDTH+50,56},
			{HWIDTH+264,106},
			{HWIDTH+264,250},
			{HWIDTH+52 ,463},
			{HWIDTH+52 ,463+60},
			{HWIDTH+10 ,463+60}
		}
	else
		n = -5
		self.points = {
			{HWIDTH-50,56},
			{HWIDTH-264,106},
			{HWIDTH-264,250},
			{HWIDTH-52 ,463},
			{HWIDTH-52 ,463+60},
			{HWIDTH-10 ,463+60}
		}
	end

	self.blocks[1].shape = love.physics.newPolygonShape(
		self.points[1][1]+n, self.points[1][2]-5,
		self.points[1][1]-n, self.points[1][2]+5,
		self.points[2][1]-n, self.points[2][2]+5,
		self.points[2][1]+n, self.points[2][2]-5
	)
	self.blocks[2].shape = love.physics.newPolygonShape(
		self.points[2][1]+n, self.points[2][2]-5,
		self.points[2][1]-n, self.points[2][2]-5,
		self.points[3][1]-n, self.points[3][2]+5,
		self.points[3][1]+n, self.points[3][2]+5
	)
	self.blocks[3].shape = love.physics.newPolygonShape(
		self.points[3][1]+n, self.points[3][2]+5,
		self.points[3][1]-n, self.points[3][2]-5,
		self.points[4][1]-n, self.points[4][2]-5,
		self.points[4][1]+n, self.points[4][2]+5
	)
	self.blocks[4].shape = love.physics.newPolygonShape(
		self.points[4][1]+n, self.points[4][2],
		self.points[4][1]-n, self.points[4][2],
		self.points[5][1]-n, self.points[5][2],
		self.points[5][1]+n, self.points[5][2]
	)
	self.blocks[5].shape = love.physics.newPolygonShape(
		self.points[5][1], self.points[5][2]+5,
		self.points[5][1], self.points[5][2]-5,
		self.points[6][1], self.points[6][2]-5,
		self.points[6][1], self.points[6][2]+5
	)


	for i=1,pointcount do
		self.blocks[i].fixture = love.physics.newFixture(self.blocks[i].body, self.blocks[i].shape)
		if i > 3 then
			self.blocks[i].fixture:setRestitution(0.3)
		else
			self.blocks[i].fixture:setRestitution(1.0)
		end
		self.blocks[i].fixture:setFriction(0.0)
	
--[[
		if i~=1 then
			if right then
				love.physics.newWeldJoint(self.blocks[i-1].body,self.blocks[i].body,WIDTH,HHEIGHT,false)
			else
				love.physics.newWeldJoint(self.blocks[i-1].body,self.blocks[i].body,0,HHEIGHT,false)
			end
		end
]]--
	end
end

function Wall:update(dt)
end

function Wall:draw()
	love.graphics.setColor(240,240,240,255)
	if self.right then
	love.graphics.polygon("fill", {
		HWIDTH,56,
		HWIDTH+50,56,
		HWIDTH+264,106,
		HWIDTH+264,250,
		HWIDTH+52 ,463,
		HWIDTH+52 ,463+60,
		HWIDTH ,463+60
	})
	else
	love.graphics.polygon("fill", {
		HWIDTH,56,
		HWIDTH-50,56,
		HWIDTH-264,106,
		HWIDTH-264,250,
		HWIDTH-52 ,463,
		HWIDTH-52 ,463+60,
		HWIDTH ,463+60
	})
	end

	love.graphics.setColor(132,132,132,255)
	--love.graphics.polygon("fill", self.block.body:getWorldPoints(self.block.shape:getPoints()))
	for i=1,#self.blocks do
		love.graphics.polygon("fill", self.blocks[i].body:getWorldPoints(self.blocks[i].shape:getPoints()))
	end
end
